﻿/************************************************************************  
 * ClassName   :  PileParametersEntity     
 * Description :       
 * Author      :  Administrator    
 * CreateTime  :  2019/4/11 10:47:12  
************************************************************************
             __
       __   (__`\
      (__`\   \\`\
       `\\`\   \\ \
         `\\`\  \\ \
           `\\`\#\\ \#
             \_ ##\_ |##
             (___)(___)##
              (0)  (0)`\##
               |~   ~ , \##
               |      |  \##
               |     /\   \##         __..---'''''-.._.._
               |     | \   `\##  _.--'                _  `.
               Y     |  \    `##'                     \`\  \
              /      |   \                             | `\ \
             /_...___|    \                            |   `\\
            /        `.    |                          /      ##
           |          |    |                         /      ####
           |          |    |                        /       ####
           | () ()    |     \     |          |  _.-'         ##
           `.        .'      `._. |______..| |-'|
             `------'           | | | |    | || |
                                | | | |    | || |
                                | | | |    | || |
                                | | | |    | || |     
                          _____ | | | |____| || |
                         /     `` |-`/     ` |` |
                         \________\__\_______\__\
                          """""""""   """""""'"""

************************************************************************
 * Copyright @ u-BIM Dev. 2018 . All rights reserved.  
************************************************************************/

using System.Collections.Generic;

namespace uBIMEarthTools.PileCheck
{
    /// <summary>
    /// 桩参数的实体类
    /// </summary>
    public class PileParametersEntity
    {
        /// <summary>
        /// 区域
        /// </summary>
        public string Region { get; set; }
        
        /// <summary>
        /// 编号
        /// </summary>
        public string Number { get; set; }

        /// <summary>
        /// 类型
        /// </summary>
        public string Type { get; set; }

        /// <summary>
        /// 坐标(X)
        /// </summary>
        public double LocationX { get; set; }

        /// <summary>
        /// 坐标(Y)
        /// </summary>
        public double LocationY { get; set; }

        /// <summary>
        /// 桩径(mm)
        /// </summary>
        public double Diameter { get; set; }

        /// <summary>
        /// 桩顶高(mm)
        /// </summary>
        public double TopOffset { get; set; }

        /// <summary>
        /// 选中的持力层
        /// </summary>
        public string SelectedBearingStratumItem { get; set; }

        /// <summary>
        /// 持力层集合
        /// </summary>
        public List<string> BearingStratumItems { get; set; }

        /// <summary>
        /// 入岩深度(Min)
        /// </summary>
        public double DepthOfRockMin { get; set; }

        /// <summary>
        /// 入岩深度(Max)
        /// </summary>
        public double DepthOfRockMax { get; set; }
    }
}
