﻿using Autodesk.Revit.DB;

namespace uBIMEarthTools.Model
{
    class GeologyParams
    {
        /// <summary>
        /// 放置位置
        /// </summary>
        public XYZ Location { get; set; }

        /// <summary>
        /// F面左距
        /// </summary>
        public double FDistance { get; set; }

        /// <summary>
        /// F面宽
        /// </summary>
        public double FWidth { get; set; }

        /// <summary>
        /// F面左边高
        /// </summary>
        public double FLeftHeight { get; set; }

        /// <summary>
        /// F面左底高
        /// </summary>
        public double FLeftBottom { get; set; }

        /// <summary>
        /// F面右边高
        /// </summary>
        public double FRightHeight { get; set; }

        /// <summary>
        /// F面右底高
        /// </summary>
        public double FRightBottom { get; set; }

        /// <summary>
        /// E面左距
        /// </summary>
        public double EDistance { get; set; }

        /// <summary>
        /// E面宽
        /// </summary>
        public double EWidth { get; set; }

        /// <summary>
        /// E面左边高
        /// </summary>
        public double ELeftHeight { get; set; }

        /// <summary>
        /// E面左底高
        /// </summary>
        public double ELeftBottom { get; set; }

        /// <summary>
        /// E面右边高
        /// </summary>
        public double ERightHeight { get; set; }

        /// <summary>
        /// E面右底高
        /// </summary>
        public double ERightBottom { get; set; }

        /// <summary>
        /// FE垂距
        /// </summary>
        public double FEOffset { get; set; }

        /// <summary>
        /// 偏移量
        /// </summary>
        public double ElevationOffset { get; set; }

        /// <summary>
        /// 旋转角度
        /// </summary>
        public double Angle { get; set; }

        /// <summary>
        /// 构造函数
        /// </summary>
        public GeologyParams() { }
    }
}
